// Copyright (C) 2012-2013 ChaosForge / Kornel Kisielewicz
// http://chaosforge.org/
//
// This file is part of NV Libraries.
// For conditions of distribution and use, see copyright notice in nv.hh
#ifndef NV_LUA_RAW_HH
#define NV_LUA_RAW_HH

#include <nv/common.hh>
#include <nv/lib/lua.hh>
#include <istream>
#include <string>
#include <map>

void nlua_toflags_set( lua_State *L, int index, nv::uint8* data, nv::uint32 count );
void nlua_toflags_array( lua_State *L, int index, nv::uint8* data, nv::uint32 count );
void nlua_toflags( lua_State *L, int index, nv::uint8* data, nv::uint32 count );

std::string nlua_typecontent( lua_State* L, int idx );
void nlua_shallowmerge( lua_State *L, int index );
void nlua_shallowcopy( lua_State *L, int index );
void nlua_shallowicopy( lua_State *L, int index );
void nlua_deepcopy( lua_State *L, int index );
void nlua_pushreversed( lua_State *L, int index );
void nlua_toset( lua_State *L, int index );
void nlua_tokeyset( lua_State *L, int index );

void nlua_register( lua_State *L, const char* fname, lua_CFunction func, int index );
void nlua_register( lua_State *L, const luaL_Reg *l, int index );
void nlua_register( lua_State *L, const char* lname, const char* fname, lua_CFunction func );
void nlua_register( lua_State *L, const char* lname, const luaL_Reg *l );

#endif // NV_LUA_RAW_HH

